package org.anjocaido.groupmanager.events;

import org.anjocaido.groupmanager.GroupManager;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;

/**
 * @author ElgarL
 *
 */
public class GMSystemEvent extends Event {
    private static final HandlerList handlers = new HandlerList();
    protected Action action;

    public GMSystemEvent(final Action action) {
        super();
        this.action = action;
    }

    //////////////////////////////
    public static HandlerList getHandlerList() {
        return handlers;
    }

    public Action getAction() {
        return this.action;
    }

    @Override
    public HandlerList getHandlers() {
        return handlers;
    }

    public void schedule(final GMSystemEvent event) {
        synchronized (GroupManager.getGMEventHandler().getServer()) {
            if (GroupManager.getGMEventHandler().getServer().getScheduler().scheduleSyncDelayedTask(GroupManager.getGMEventHandler().getPlugin(), new Runnable() {
                @Override
                public void run() {
                    GroupManager.getGMEventHandler().getServer().getPluginManager().callEvent(event);
                }
            }, 1) == -1)
                GroupManager.logger.warning("Could not schedule GM Event.");
        }
    }

    public enum Action {
        RELOADED,
        SAVED,
        DEFAULT_GROUP_CHANGED,
        VALIDATE_TOGGLE,
    }
}